//+------------------------------------------------------------------+
//|																gePriceCanal.mq4		|
//|                      Copyright  2007, ver 1.0							|
//|                      Forte928           									|
//+------------------------------------------------------------------+
#property copyright "Forte928"
#property link      ""
#define		IndicatorName "gePriceCanal"

#define		DaySecond		86400
#define		HourSecond		3600
#define		MinuteSecond	60
#property indicator_chart_window
//#property indicator_separate_window


#property indicator_buffers 1
#property indicator_color1 Yellow

extern bool		Fixed			=false;
extern int		HourPrd		=1;
extern int		LineCount	=10;
extern int		LineFirst	=10;
extern int		LineStep		=5;
extern color	OpenColor	= Yellow;
extern color	FirstColor	= Red;
extern color	NextColor	= SpringGreen;
//double  FreqTOL  =0.0001;//Tolerance of frequency calculation for Method 1

double	FxView1[];
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Custom indicator initialization function ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int init()
  {
//---- initialization program values  --------------------------------
	SetupChartLineColor(0,FxView1,0,1,OpenColor,"Line1");// SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1); SetIndexBuffer(0,ValueBuf0);
	SetIndexStyle(0,DRAW_LINE,STYLE_DOT,1,OpenColor);
   IndicatorShortName(IndicatorName);
  	IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//----
   return(0);
  }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Custom indicator deinitialization function ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int deinit()
  {
//----
	ObjectsDeleteAll(0,OBJ_TREND);
//----
   return(0);
  }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Start defination ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int start()
{
//+-------------------------- Begin Cycle ---------------------------------------------------+\\
	datetime TimeLast=Time[0];
	TimeLast=TimeLast-TimeSeconds(TimeLast);
	datetime TimeFirst=TimeLast-HourPrd*HourSecond+TimeMinute(TimeLast)*60;
	if (Fixed==true) {
		TimeFirst=Time[0];
		if (MathAbs(TimeHour(TimeFirst)-HourPrd)<=1) TimeFirst=TimeFirst-DaySecond;
		TimeFirst=TimeFirst-(TimeHour(TimeFirst)-HourPrd)*HourSecond-TimeMinute(TimeFirst)*MinuteSecond-TimeSeconds(TimeFirst);
		//Print(TimeToStr(TimeFirst,TIME_DATE|TIME_MINUTES|TIME_SECONDS));
	}
	
	TimeFirst=Time[iBarShift(Symbol(),Period(),TimeFirst,false)];
	int IndexFirst=iBarShift(Symbol(),Period(),TimeFirst,false);
	int IndexLast=iBarShift(Symbol(),Period(),TimeLast,false);
	double PriceFirst=Open[IndexFirst];
	
	
	ObjectsDeleteAll(0,OBJ_TREND);
	//For 
	InitChart(FxView1);
	for (int Ix=IndexFirst;Ix>=IndexLast;Ix--) FxView1[Ix]=PriceFirst;
	PriceFirst=PriceFirst+LineFirst*Point;
	DrawLineCanal("LinePrice1",TimeFirst,PriceFirst,TimeLast,PriceFirst,1,FirstColor);
	for (Ix=1;Ix<=LineCount;Ix++)
		DrawLineCanal("LinePrice"+(Ix+1),TimeFirst,PriceFirst+LineStep*Ix*Point,TimeLast,PriceFirst+LineStep*Ix*Point,1,NextColor);
	
//----
   return;
  }
//-----------------------------------------------------------------------------------------------
void DrawLineCanal(string iName,datetime iTimeFirst,double iPriceFirst,datetime iTimeLast,double iPriceLast,int iWidth,color iColor)
{
	ObjectCreate(iName,OBJ_TREND,0,iTimeFirst,iPriceFirst,iTimeLast,iPriceLast);
	ObjectSet(iName,OBJPROP_COLOR,iColor);
	ObjectSet(iName,OBJPROP_WIDTH,iWidth);
	ObjectSet(iName,OBJPROP_RAY,false);
	ObjectSet(iName,OBJPROP_STYLE,STYLE_DOT);
	return;
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~														 Style active Line																~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void SetupChartLine(int Index,double& ViewAy[],int Style,int Width,string Label)
{
	switch(Style)
	{
		case 0 : SetIndexStyle(Index,DRAW_LINE,STYLE_SOLID,Width);break;
		case 1 : SetIndexStyle(Index,DRAW_HISTOGRAM,STYLE_SOLID,Width);break;
		case 2 : SetIndexStyle(Index,DRAW_ARROW,STYLE_SOLID,Width);break;
		default : SetIndexStyle(Index,DRAW_LINE,STYLE_SOLID,Width);break;
	}
	if (Label!="") SetIndexLabel(Index,Label);
	SetIndexBuffer(Index,ViewAy);
	return(0);
}
//------------------------------------------ Style active Line --------------------------
void SetupChartLineColor(int Index,double& ViewAy[],int Style,int Width,color ColorLine,string Label)
{
	switch(Style)
	{
		case 0 : SetIndexStyle(Index,DRAW_LINE,STYLE_SOLID,Width,ColorLine);break;
		case 1 : SetIndexStyle(Index,DRAW_HISTOGRAM,STYLE_SOLID,Width,ColorLine);break;
		case 2 : SetIndexStyle(Index,DRAW_ARROW,STYLE_SOLID,Width,ColorLine);break;
		default : SetIndexStyle(Index,DRAW_LINE,STYLE_SOLID,Width,ColorLine);break;
	}
	if (Label!="") SetIndexLabel(Index,Label);
	SetIndexBuffer(Index,ViewAy);
	return(0);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void InitChart(double& ayShift[])									// 
{
	if (ArraySize(ayShift)>0) ArrayInitialize(ayShift,EMPTY_VALUE);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

